from ScrumPy.Util import Set

reactions = ['TRANS-RXN-354', '3.4.21.107-RXN', 'PEPTIDYLPROLYL-ISOMERASE-RXN', 'RXN0-5121',
             'RXN0-5061', '5.99.1.3-RXN', '5.1.3.20-RXN', 'RXN-22462','TRANS-RXN-356', 'TRANS-RXN-359',
             'PHOSPHOGLUCMUT-RXN', 'RXN0-5122', 'MYRISTOYLACYLTRAN-RXN','KDO-8PPHOSPHAT-RXN',
             '3.4.21.102-RXN','RXN-22461', 'TRANS-RXN0-592', 'TRANS-RXN-357','RXN0-4361',
             'MYRPALMTRAN-RXN', 'TRANS-RXN-360', 'TRANS-RXN-237', 'TRANS-RXN-355']



def ExtractReacs(reacs = None):

    if reacs == None:
        rv = reactions
        
    return rv

def ModelReacs(m , reacs): ## returns list of metabolic reactions present in model out of reactions from tradis

    """
    pre: m = model, list of reactions from tradis comparison genes
    post: list of metabolic reactions present in model
    
    """

    rv = []
    for r in reacs:
        if r in m.sm.cnames:
            rv.append(r)

    return rv

def LPS_Pathway(m): ## return solution of LPS synthesis in background of biomass formation
    
    """
    pre: m = model
    post: reactions involved in LPS formation
    
    """
    
    lp = m.GetLP()
    lp.SetObjective(m.sm.cnames)
    lp.SetFixedFlux({'lps_bm_tx':-1})
    lp.Solve()
    sol = lp.GetPrimSol()

    return sol

def KnockOut(m, model_reacs): ## returns solution of knocking out reactions involved in LPS formation

    """
    pre: m = model, reacs = list of reactions
    post: solution of knocking out each reaction
    """
    lp = m.GetLP()
    lp.SetObjective(m.sm.cnames)
    lp.SetFixedFlux({'lps_bm_tx':-1})
    for r in model_reacs:
        if r in m.sm.cnames:
            lp.SetFixedFlux({r:0})
            lp.Solve()
            sol = lp.GetPrimSol()
            lp.ClearFluxConstraint(r)
            print(r)
    #return sol


    
